% Program and File Organization

Files should be organized, named, and laid out as specified in
\cite{codingstd}, however {\tt .icc} files should not be used at 
all.
Short functions (template or otherwise) may be inlined and defined 
in a header file following class declarations.
Non-inlined function definitions should only appear in {\tt .cc}
files.
Explicit instantiation requests for non-inlined template functions
and template classes must be made in the same {\tt .cc} file for 
each required type.

\subsection{Header file organization}

Header files should be organized as specified in \cite{codingstd}.

\subsubsection{Include guards}

All header files should contain a file guard of the form
\begin{verbatim}
#ifndef FILENAME_HH
#define FILENAME_HH
 
<file body>    

#endif // FILENAME_HH
\end{verbatim}
to prevent multiple inclusion and improve compilation times.

\subsubsection{CVS tags}

Each source file should declare a {\tt char} array named {\tt rcsid} 
in the anonymous namespace as follows:
\begin{verbatim} 
namespace {
    const char rcsid[] = "@(#) $Id: handbookOrganization.tex,v 1.2 2001/04/17 00:52:17 Philip.Charlton Exp $"; 
};
\end{verbatim}
The RCS ID will be inserted between the dollar signs by CVS when the
source file is checked out and the 
constant {\tt rcsid} can then be used in messages, warnings and errors
just as with 
any other constant character array.

\subsubsection{Include directives}

All \verb+#include+ statements should be grouped together near the 
top of the file after the include guards.
Includes should be logically grouped together, with the groups 
separated by a blank line.
Include statements should appear in the following order: system 
includes, LDAS application includes, data conditioning API includes.

\subsubsection{Inline declarations}

Definitions of inline functions should appear after the class declaration.
Functions should not be declared {\tt inline} within the class
declaration, only in the function definition. 

\subsection{Source file organization}

Source files should be organized as specified in \cite{codingstd}.

\subsubsection{CVS tags}

\subsubsection{Method declarations}

\subsubsection{Instantiations}

Definitions of templated classes and functions should always appear in
a {\tt .cc} file, as should explicit instantiation requests for the
template types which are needed.
See Section~\ref{sss:InstantiationRules} and \cite{codingstd} for more
details.

